#include "buffer.h"

sockbuf::sockbuf()
{
  buffer=NULL;
};

sockbuf::sockbuf (int Sock,int Size)
{
  sock=Sock;
  buffer=new char[Size+1];
#ifdef LINUX
  bzero(buffer,Size);
#endif
#ifdef SPARC /*My kingdom for a bzero()*/
  for (unsigned int dummy=0;dummy<Size;dummy++)
   buffer[dummy]=0x0;
#endif
  buffersize=Size;
  lastpoint=buffer;
};

sockbuf::~sockbuf()
{
  fsync(sock);
  shutdown(sock,0);
  close(sock);
  delete buffer;
};

   
   
int sockbuf::readl(char *Buffer)
{
  while(1)
    {
      if (strchr(buffer,'\n')==NULL)
        {
#ifdef LINUX
          int howmanyread=read(sock,lastpoint,buffer+buffersize-lastpoint);
#endif
#ifdef SPARC
          int howmanyread=read(sock,lastpoint,buffer+buffersize-lastpoint);
          while((howmanyread==-1) & (errno=11))
           howmanyread=read(sock,lastpoint,buffer+buffersize-lastpoint);
#endif
          if ((howmanyread==0)&(lastpoint<buffer+buffersize-1))
            return 0;
          if (howmanyread==-1)
            return -1;
          /*by now howmanyread>0*/
          lastpoint+=howmanyread;
          *lastpoint=0x0;
        }          
      else
        {
          strtok(buffer,"\n");
          strcpy(Buffer,buffer);
          int tmplen=strlen(Buffer);
          Buffer[tmplen]='\n';
          Buffer[tmplen+1]=0x0;
          strcpy(buffer,buffer+strlen(buffer)+1);
          lastpoint-=(tmplen+1);
          return strlen(Buffer);
        };
    };
};


int sockbuf::writel(char *buf)
{
  int response=0;
  while(1)
    {
       response=write(sock,buf,strlen(buf));
       fsync(sock);
#ifdef LINUX
       if (response==-1)
#endif
#ifdef SPARC
       if ((response==-1)&(errno!=11))
#endif
         return -1;
       if ((response<strlen(buf))&(errno!=11))
         buf+=response;
       if (response==strlen(buf))
         return 1;
    };    
  /*should never be reached*/  
  return 0;
};
